#include <sys/types.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

int
main(void)
{
	struct flock flock;
	int error, fd;

	fd = open("/tmp/lockfile", O_CREAT|O_WRONLY);
	if (fd == -1)
		err(1, "open");

	printf("My pid: %d\n", getpid());

	flock.l_type = F_WRLCK;
	flock.l_start = 0;
	flock.l_whence = SEEK_SET;
	flock.l_len = 0;

	if (fcntl(fd, F_SETLK, &flock) == -1) {
		error = errno;
		warn("fcntl[1]");
		if (error == EAGAIN) {
			if (fcntl(fd, F_GETLK, &flock) == -1)
				err(1, "fcntl[2]");
			printf("PID=%d has the lock\n", flock.l_pid);
		}
		return (1);
	}

	while (1)
		sleep(1);

	return (0);

}
